Imports System.Runtime.InteropServices
Public Class Calculator
    Inherits System.Windows.Forms.Form
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure BaseUnits
        Public Width As Int16
        Public Height As Int16
    End Structure

    Declare Auto Function GetDialogBaseUnits Lib "user32.dll" () As BaseUnits

#Region " Windows Form Designer generated code "


    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        Dim x As Int16
        For x = 0 To (FontFamily.Families.Length - 1)
            Me.cbFace.Items.Add(FontFamily.Families(x).Name)
        Next
        Me.cbFace.SelectedIndex = 0

        With Me.cbStyle.Items
            .Add("Regular")
            .Add("Italic")
            .Add("Bold")
            .Add("Bold Italic")
        End With
        Me.cbStyle.SelectedIndex = 0

        With Me.cbSize.Items
            .Add(8)
            .Add(9)
            .Add(10)
            .Add(11)
            .Add(12)
            .Add(14)
            .Add(16)
            .Add(18)
            .Add(20)
            .Add(22)
            .Add(24)
            .Add(26)
            .Add(28)
            .Add(36)
            .Add(48)
            .Add(72)
        End With
        Me.cbSize.SelectedIndex = 0

        Dim dlu As BaseUnits = GetDialogBaseUnits()

        Me.tbSysHDU.Text = dlu.Height / 8
        Me.tbSysVDU.Text = dlu.Width / 4

        With SystemInformation.MenuFont
            tbMenuFont.Text = .Size & " point "
            tbMenuFont.Text += .Name
        End With
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents cbFace As System.Windows.Forms.ComboBox
    Friend WithEvents cbStyle As System.Windows.Forms.ComboBox
    Friend WithEvents cbSize As System.Windows.Forms.ComboBox
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents Label6 As System.Windows.Forms.Label
    Friend WithEvents Label7 As System.Windows.Forms.Label
    Friend WithEvents Label8 As System.Windows.Forms.Label
    Friend WithEvents Label9 As System.Windows.Forms.Label
    Friend WithEvents Label10 As System.Windows.Forms.Label
    Friend WithEvents Label11 As System.Windows.Forms.Label
    Friend WithEvents Label12 As System.Windows.Forms.Label
    Friend WithEvents Label13 As System.Windows.Forms.Label
    Friend WithEvents tbAvgWidth As System.Windows.Forms.TextBox
    Friend WithEvents tbHeight As System.Windows.Forms.TextBox
    Friend WithEvents tbHDU As System.Windows.Forms.TextBox
    Friend WithEvents tbVDU As System.Windows.Forms.TextBox
    Friend WithEvents tbGrid As System.Windows.Forms.TextBox
    Friend WithEvents tbUnrelated As System.Windows.Forms.TextBox
    Friend WithEvents tbRelated As System.Windows.Forms.TextBox
    Friend WithEvents tbLabel As System.Windows.Forms.TextBox
    Friend WithEvents tbMargins As System.Windows.Forms.TextBox
    Friend WithEvents tbButton As System.Windows.Forms.TextBox
    Friend WithEvents btnRecalc As System.Windows.Forms.Button
    Friend WithEvents btnPrint As System.Windows.Forms.Button
    Friend WithEvents pnlSystemDU As System.Windows.Forms.Panel
    Friend WithEvents tbSysHDU As System.Windows.Forms.TextBox
    Friend WithEvents Label14 As System.Windows.Forms.Label
    Friend WithEvents tbSysVDU As System.Windows.Forms.TextBox
    Friend WithEvents Label15 As System.Windows.Forms.Label
    Friend WithEvents Label16 As System.Windows.Forms.Label
    Friend WithEvents tbMenuFont As System.Windows.Forms.TextBox
    Friend WithEvents PrintDocument1 As System.Drawing.Printing.PrintDocument
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.cbFace = New System.Windows.Forms.ComboBox
        Me.cbStyle = New System.Windows.Forms.ComboBox
        Me.cbSize = New System.Windows.Forms.ComboBox
        Me.btnRecalc = New System.Windows.Forms.Button
        Me.btnPrint = New System.Windows.Forms.Button
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.tbUnrelated = New System.Windows.Forms.TextBox
        Me.tbRelated = New System.Windows.Forms.TextBox
        Me.tbLabel = New System.Windows.Forms.TextBox
        Me.tbMargins = New System.Windows.Forms.TextBox
        Me.tbButton = New System.Windows.Forms.TextBox
        Me.tbGrid = New System.Windows.Forms.TextBox
        Me.tbVDU = New System.Windows.Forms.TextBox
        Me.tbHDU = New System.Windows.Forms.TextBox
        Me.tbHeight = New System.Windows.Forms.TextBox
        Me.tbAvgWidth = New System.Windows.Forms.TextBox
        Me.Label13 = New System.Windows.Forms.Label
        Me.Label12 = New System.Windows.Forms.Label
        Me.Label11 = New System.Windows.Forms.Label
        Me.Label10 = New System.Windows.Forms.Label
        Me.Label9 = New System.Windows.Forms.Label
        Me.Label8 = New System.Windows.Forms.Label
        Me.Label7 = New System.Windows.Forms.Label
        Me.Label6 = New System.Windows.Forms.Label
        Me.Label5 = New System.Windows.Forms.Label
        Me.Label4 = New System.Windows.Forms.Label
        Me.pnlSystemDU = New System.Windows.Forms.Panel
        Me.tbMenuFont = New System.Windows.Forms.TextBox
        Me.Label16 = New System.Windows.Forms.Label
        Me.tbSysVDU = New System.Windows.Forms.TextBox
        Me.Label15 = New System.Windows.Forms.Label
        Me.tbSysHDU = New System.Windows.Forms.TextBox
        Me.Label14 = New System.Windows.Forms.Label
        Me.PrintDocument1 = New System.Drawing.Printing.PrintDocument
        Me.Panel1.SuspendLayout()
        Me.pnlSystemDU.SuspendLayout()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(16, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(33, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Face:"
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.Location = New System.Drawing.Point(304, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(33, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Style:"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(416, 8)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(29, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Size:"
        '
        'cbFace
        '
        Me.cbFace.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple
        Me.cbFace.Location = New System.Drawing.Point(16, 24)
        Me.cbFace.Name = "cbFace"
        Me.cbFace.Size = New System.Drawing.Size(272, 160)
        Me.cbFace.TabIndex = 3
        Me.cbFace.Text = "Face"
        '
        'cbStyle
        '
        Me.cbStyle.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple
        Me.cbStyle.Location = New System.Drawing.Point(304, 24)
        Me.cbStyle.Name = "cbStyle"
        Me.cbStyle.Size = New System.Drawing.Size(96, 160)
        Me.cbStyle.TabIndex = 4
        Me.cbStyle.Text = "Style"
        '
        'cbSize
        '
        Me.cbSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.Simple
        Me.cbSize.Location = New System.Drawing.Point(416, 24)
        Me.cbSize.Name = "cbSize"
        Me.cbSize.Size = New System.Drawing.Size(72, 160)
        Me.cbSize.TabIndex = 5
        Me.cbSize.Text = "Size"
        '
        'btnRecalc
        '
        Me.btnRecalc.Location = New System.Drawing.Point(504, 8)
        Me.btnRecalc.Name = "btnRecalc"
        Me.btnRecalc.Size = New System.Drawing.Size(88, 23)
        Me.btnRecalc.TabIndex = 6
        Me.btnRecalc.Text = "Calculate"
        '
        'btnPrint
        '
        Me.btnPrint.Location = New System.Drawing.Point(504, 40)
        Me.btnPrint.Name = "btnPrint"
        Me.btnPrint.Size = New System.Drawing.Size(88, 23)
        Me.btnPrint.TabIndex = 7
        Me.btnPrint.Text = "Print"
        '
        'Panel1
        '
        Me.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel1.Controls.Add(Me.tbUnrelated)
        Me.Panel1.Controls.Add(Me.tbRelated)
        Me.Panel1.Controls.Add(Me.tbLabel)
        Me.Panel1.Controls.Add(Me.tbMargins)
        Me.Panel1.Controls.Add(Me.tbButton)
        Me.Panel1.Controls.Add(Me.tbGrid)
        Me.Panel1.Controls.Add(Me.tbVDU)
        Me.Panel1.Controls.Add(Me.tbHDU)
        Me.Panel1.Controls.Add(Me.tbHeight)
        Me.Panel1.Controls.Add(Me.tbAvgWidth)
        Me.Panel1.Controls.Add(Me.Label13)
        Me.Panel1.Controls.Add(Me.Label12)
        Me.Panel1.Controls.Add(Me.Label11)
        Me.Panel1.Controls.Add(Me.Label10)
        Me.Panel1.Controls.Add(Me.Label9)
        Me.Panel1.Controls.Add(Me.Label8)
        Me.Panel1.Controls.Add(Me.Label7)
        Me.Panel1.Controls.Add(Me.Label6)
        Me.Panel1.Controls.Add(Me.Label5)
        Me.Panel1.Controls.Add(Me.Label4)
        Me.Panel1.Location = New System.Drawing.Point(16, 184)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(472, 144)
        Me.Panel1.TabIndex = 8
        '
        'tbUnrelated
        '
        Me.tbUnrelated.Location = New System.Drawing.Point(352, 104)
        Me.tbUnrelated.Name = "tbUnrelated"
        Me.tbUnrelated.TabIndex = 28
        Me.tbUnrelated.Text = ""
        '
        'tbRelated
        '
        Me.tbRelated.Location = New System.Drawing.Point(352, 80)
        Me.tbRelated.Name = "tbRelated"
        Me.tbRelated.TabIndex = 27
        Me.tbRelated.Text = ""
        '
        'tbLabel
        '
        Me.tbLabel.Location = New System.Drawing.Point(352, 56)
        Me.tbLabel.Name = "tbLabel"
        Me.tbLabel.TabIndex = 26
        Me.tbLabel.Text = ""
        '
        'tbMargins
        '
        Me.tbMargins.Location = New System.Drawing.Point(352, 32)
        Me.tbMargins.Name = "tbMargins"
        Me.tbMargins.TabIndex = 25
        Me.tbMargins.Text = ""
        '
        'tbButton
        '
        Me.tbButton.Location = New System.Drawing.Point(352, 8)
        Me.tbButton.Name = "tbButton"
        Me.tbButton.TabIndex = 24
        Me.tbButton.Text = ""
        '
        'tbGrid
        '
        Me.tbGrid.Location = New System.Drawing.Point(136, 104)
        Me.tbGrid.Name = "tbGrid"
        Me.tbGrid.TabIndex = 23
        Me.tbGrid.Text = ""
        '
        'tbVDU
        '
        Me.tbVDU.Location = New System.Drawing.Point(136, 80)
        Me.tbVDU.Name = "tbVDU"
        Me.tbVDU.TabIndex = 22
        Me.tbVDU.Text = ""
        '
        'tbHDU
        '
        Me.tbHDU.Location = New System.Drawing.Point(136, 56)
        Me.tbHDU.Name = "tbHDU"
        Me.tbHDU.TabIndex = 21
        Me.tbHDU.Text = ""
        '
        'tbHeight
        '
        Me.tbHeight.Location = New System.Drawing.Point(136, 32)
        Me.tbHeight.Name = "tbHeight"
        Me.tbHeight.TabIndex = 20
        Me.tbHeight.Text = ""
        '
        'tbAvgWidth
        '
        Me.tbAvgWidth.Location = New System.Drawing.Point(136, 8)
        Me.tbAvgWidth.Name = "tbAvgWidth"
        Me.tbAvgWidth.TabIndex = 19
        Me.tbAvgWidth.Text = ""
        '
        'Label13
        '
        Me.Label13.AutoSize = True
        Me.Label13.Location = New System.Drawing.Point(240, 106)
        Me.Label13.Name = "Label13"
        Me.Label13.TabIndex = 18
        Me.Label13.Text = "Unrelated Widgets:"
        '
        'Label12
        '
        Me.Label12.AutoSize = True
        Me.Label12.Location = New System.Drawing.Point(248, 82)
        Me.Label12.Name = "Label12"
        Me.Label12.Size = New System.Drawing.Size(90, 16)
        Me.Label12.TabIndex = 17
        Me.Label12.Text = "Related Widgets:"
        '
        'Label11
        '
        Me.Label11.AutoSize = True
        Me.Label11.Location = New System.Drawing.Point(256, 58)
        Me.Label11.Name = "Label11"
        Me.Label11.Size = New System.Drawing.Size(82, 16)
        Me.Label11.TabIndex = 16
        Me.Label11.Text = "Label Distance:"
        '
        'Label10
        '
        Me.Label10.AutoSize = True
        Me.Label10.Location = New System.Drawing.Point(288, 34)
        Me.Label10.Name = "Label10"
        Me.Label10.Size = New System.Drawing.Size(48, 16)
        Me.Label10.TabIndex = 15
        Me.Label10.Text = "Margins:"
        '
        'Label9
        '
        Me.Label9.AutoSize = True
        Me.Label9.Location = New System.Drawing.Point(272, 10)
        Me.Label9.Name = "Label9"
        Me.Label9.Size = New System.Drawing.Size(65, 16)
        Me.Label9.TabIndex = 14
        Me.Label9.Text = "Button Size:"
        '
        'Label8
        '
        Me.Label8.AutoSize = True
        Me.Label8.Location = New System.Drawing.Point(24, 106)
        Me.Label8.Name = "Label8"
        Me.Label8.Size = New System.Drawing.Size(109, 16)
        Me.Label8.TabIndex = 13
        Me.Label8.Text = "Recommended Grid:"
        '
        'Label7
        '
        Me.Label7.AutoSize = True
        Me.Label7.Location = New System.Drawing.Point(96, 82)
        Me.Label7.Name = "Label7"
        Me.Label7.Size = New System.Drawing.Size(29, 16)
        Me.Label7.TabIndex = 12
        Me.Label7.Text = "vDU:"
        '
        'Label6
        '
        Me.Label6.AutoSize = True
        Me.Label6.Location = New System.Drawing.Point(96, 58)
        Me.Label6.Name = "Label6"
        Me.Label6.Size = New System.Drawing.Size(30, 16)
        Me.Label6.TabIndex = 11
        Me.Label6.Text = "hDU:"
        '
        'Label5
        '
        Me.Label5.AutoSize = True
        Me.Label5.Location = New System.Drawing.Point(40, 34)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(93, 16)
        Me.Label5.TabIndex = 10
        Me.Label5.Text = "Character Height:"
        '
        'Label4
        '
        Me.Label4.AutoSize = True
        Me.Label4.Location = New System.Drawing.Point(16, 10)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(112, 16)
        Me.Label4.TabIndex = 9
        Me.Label4.Text = "Avg Character Width:"
        '
        'pnlSystemDU
        '
        Me.pnlSystemDU.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.pnlSystemDU.Controls.Add(Me.tbMenuFont)
        Me.pnlSystemDU.Controls.Add(Me.Label16)
        Me.pnlSystemDU.Controls.Add(Me.tbSysVDU)
        Me.pnlSystemDU.Controls.Add(Me.Label15)
        Me.pnlSystemDU.Controls.Add(Me.tbSysHDU)
        Me.pnlSystemDU.Controls.Add(Me.Label14)
        Me.pnlSystemDU.Location = New System.Drawing.Point(16, 336)
        Me.pnlSystemDU.Name = "pnlSystemDU"
        Me.pnlSystemDU.Size = New System.Drawing.Size(472, 64)
        Me.pnlSystemDU.TabIndex = 9
        '
        'tbMenuFont
        '
        Me.tbMenuFont.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tbMenuFont.Location = New System.Drawing.Point(136, 32)
        Me.tbMenuFont.Name = "tbMenuFont"
        Me.tbMenuFont.Size = New System.Drawing.Size(320, 20)
        Me.tbMenuFont.TabIndex = 25
        Me.tbMenuFont.Text = ""
        '
        'Label16
        '
        Me.Label16.AutoSize = True
        Me.Label16.Location = New System.Drawing.Point(48, 32)
        Me.Label16.Name = "Label16"
        Me.Label16.Size = New System.Drawing.Size(61, 16)
        Me.Label16.TabIndex = 24
        Me.Label16.Text = "Menu Font:"
        '
        'tbSysVDU
        '
        Me.tbSysVDU.Location = New System.Drawing.Point(352, 8)
        Me.tbSysVDU.Name = "tbSysVDU"
        Me.tbSysVDU.TabIndex = 23
        Me.tbSysVDU.Text = ""
        '
        'Label15
        '
        Me.Label15.AutoSize = True
        Me.Label15.Location = New System.Drawing.Point(264, 8)
        Me.Label15.Name = "Label15"
        Me.Label15.Size = New System.Drawing.Size(70, 16)
        Me.Label15.TabIndex = 22
        Me.Label15.Text = "System vDU:"
        '
        'tbSysHDU
        '
        Me.tbSysHDU.Location = New System.Drawing.Point(136, 8)
        Me.tbSysHDU.Name = "tbSysHDU"
        Me.tbSysHDU.TabIndex = 21
        Me.tbSysHDU.Text = ""
        '
        'Label14
        '
        Me.Label14.AutoSize = True
        Me.Label14.Location = New System.Drawing.Point(48, 8)
        Me.Label14.Name = "Label14"
        Me.Label14.Size = New System.Drawing.Size(71, 16)
        Me.Label14.TabIndex = 20
        Me.Label14.Text = "System hDU:"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(608, 413)
        Me.Controls.Add(Me.pnlSystemDU)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.btnPrint)
        Me.Controls.Add(Me.btnRecalc)
        Me.Controls.Add(Me.cbSize)
        Me.Controls.Add(Me.cbStyle)
        Me.Controls.Add(Me.cbFace)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Form1"
        Me.Text = "Calculator"
        Me.Panel1.ResumeLayout(False)
        Me.pnlSystemDU.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnRecalc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecalc.Click
        Dim theFont As Font
        Dim theFamily As String = Me.cbFace.SelectedItem
        Dim theStyle As FontStyle

        Try
            theStyle = CType([Enum].Parse(GetType(FontStyle), Me.cbStyle.SelectedItem), FontStyle)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        theFont = New Font(theFamily, CSng(Me.cbSize.SelectedItem), theStyle, GraphicsUnit.Pixel)

        With theFont
            Dim hDU = .Size / 4
            Dim vDU = .Size / 8
            Dim rndHDU = Math.Round(hDU)
            Dim rndVDU = Math.Round(vDU)

            Me.tbAvgWidth.Text = .Size
            Me.tbHeight.Text = .Height
            Me.tbHDU.Text = hDU
            Me.tbVDU.Text = vDU
            Me.tbGrid.Text = rndHDU & "h x " & rndVDU & "v"
            Me.tbButton.Text = (rndHDU * 14) & "h x 50v"
            Me.tbMargins.Text = (rndHDU * 7) & "h x " & (rndVDU * 7) & "v"
            Me.tbLabel.Text = (rndHDU * 3)
            Me.tbRelated.Text = (rndHDU * 4)
            Me.tbUnrelated.Text = (rndHDU * 7)

        End With

    End Sub

    Private Declare Function BitBlt Lib "gdi32.dll" Alias "BitBlt" (ByVal _
       hdcDest As IntPtr, ByVal nXDest As Integer, ByVal nYDest As _
       Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal _
       hdcSrc As IntPtr, ByVal nXSrc As Integer, ByVal nYSrc As Integer, _
       ByVal dwRop As System.Int32) As Long
    Dim memoryImage As Bitmap
    Private Sub CaptureScreen()
        Dim mygraphics As Graphics = Me.CreateGraphics()
        Dim s As Size = Me.Size
        memoryImage = New Bitmap(s.Width, s.Height, mygraphics)
        Dim memoryGraphics As Graphics = Graphics.FromImage(memoryImage)
        Dim dc1 As IntPtr = mygraphics.GetHdc
        Dim dc2 As IntPtr = memoryGraphics.GetHdc
        BitBlt(dc2, 0, 0, Me.ClientRectangle.Width, _
           Me.ClientRectangle.Height, dc1, 0, 0, 13369376)
        mygraphics.ReleaseHdc(dc1)
        memoryGraphics.ReleaseHdc(dc2)
    End Sub
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, _
       ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles _
       PrintDocument1.PrintPage
        e.Graphics.DrawImage(memoryImage, 0, 0)
    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        CaptureScreen()
        PrintDocument1.Print()
    End Sub
End Class
