using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ComplexAttributesCSharp
{
	/// <summary>
	/// Summary description for ControlSamples.
	/// </summary>
	public class ControlSamples : System.Windows.Forms.Form
	{
		BindingManagerBase bmbDates;
		
		internal System.Data.OleDb.OleDbCommand OleDbInsertCommand1;
		internal System.Data.OleDb.OleDbConnection cnChapter11;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbCommand OleDbUpdateCommand1;
		internal System.Windows.Forms.Panel Panel2;
		internal System.Windows.Forms.Button btnSetFormat;
		internal System.Windows.Forms.DateTimePicker dtpCustomFormat;
		internal System.Windows.Forms.TextBox tbCustomFormat;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.RadioButton rbTime;
		internal System.Windows.Forms.RadioButton rbLong;
		internal System.Windows.Forms.RadioButton rbShort;
		internal System.Windows.Forms.DateTimePicker dtpFormat;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.ImageList ImageList1;
		internal System.Windows.Forms.Label Label7;
		internal System.Data.OleDb.OleDbDataAdapter daDates;
		internal System.Data.OleDb.OleDbCommand OleDbDeleteCommand1;
		internal System.Windows.Forms.Panel pnlDates;
		internal System.Windows.Forms.Button btnNextDate;
		internal System.Windows.Forms.Button btnPreviousDate;
		internal System.Windows.Forms.TextBox tbUTC;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbActual;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Panel Panel3;
		internal System.Windows.Forms.CheckBox CheckBox1;
		internal System.Windows.Forms.Label Label6;
		private ComplexAttributesCSharp.dsChapter11 dsChapter11;
		private System.ComponentModel.IContainer components;

		public ControlSamples()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daDates.Fill(this.dsChapter11.Dates);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message);
			}


				bmbDates = this.BindingContext[this.dsChapter11, "Dates"];

				Binding b;
				b = this.tbUTC.DataBindings["Text"];
				b.Format += new ConvertEventHandler(ToUTC);
				b.Format += new ConvertEventHandler(ToLocal);
	
				this.dtpFormat.Value = DateTime.Today;

			}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ControlSamples));
			this.OleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.cnChapter11 = new System.Data.OleDb.OleDbConnection();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.OleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.Panel2 = new System.Windows.Forms.Panel();
			this.btnSetFormat = new System.Windows.Forms.Button();
			this.dtpCustomFormat = new System.Windows.Forms.DateTimePicker();
			this.tbCustomFormat = new System.Windows.Forms.TextBox();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.Panel1 = new System.Windows.Forms.Panel();
			this.rbTime = new System.Windows.Forms.RadioButton();
			this.rbLong = new System.Windows.Forms.RadioButton();
			this.rbShort = new System.Windows.Forms.RadioButton();
			this.dtpFormat = new System.Windows.Forms.DateTimePicker();
			this.Label3 = new System.Windows.Forms.Label();
			this.ImageList1 = new System.Windows.Forms.ImageList(this.components);
			this.Label7 = new System.Windows.Forms.Label();
			this.daDates = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.pnlDates = new System.Windows.Forms.Panel();
			this.btnNextDate = new System.Windows.Forms.Button();
			this.btnPreviousDate = new System.Windows.Forms.Button();
			this.tbUTC = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbActual = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.Panel3 = new System.Windows.Forms.Panel();
			this.CheckBox1 = new System.Windows.Forms.CheckBox();
			this.Label6 = new System.Windows.Forms.Label();
			this.dsChapter11 = new ComplexAttributesCSharp.dsChapter11();
			this.Panel2.SuspendLayout();
			this.Panel1.SuspendLayout();
			this.pnlDates.SuspendLayout();
			this.Panel3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsChapter11)).BeginInit();
			this.SuspendLayout();
			// 
			// OleDbInsertCommand1
			// 
			this.OleDbInsertCommand1.CommandText = "INSERT INTO Dates(SampleDate) VALUES (?)";
			this.OleDbInsertCommand1.Connection = this.cnChapter11;
			this.OleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("SampleDate", System.Data.OleDb.OleDbType.DBDate, 0, "SampleDate"));
			// 
			// cnChapter11
			// 
			this.cnChapter11.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""Chapter 11.mdb"";Mode=Share Deny None;Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT SampleDate FROM Dates";
			this.OleDbSelectCommand2.Connection = this.cnChapter11;
			// 
			// OleDbUpdateCommand1
			// 
			this.OleDbUpdateCommand1.CommandText = "UPDATE Dates SET SampleDate = ? WHERE (SampleDate = ?)";
			this.OleDbUpdateCommand1.Connection = this.cnChapter11;
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("SampleDate", System.Data.OleDb.OleDbType.DBDate, 0, "SampleDate"));
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_SampleDate", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SampleDate", System.Data.DataRowVersion.Original, null));
			// 
			// Panel2
			// 
			this.Panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel2.Controls.Add(this.btnSetFormat);
			this.Panel2.Controls.Add(this.dtpCustomFormat);
			this.Panel2.Controls.Add(this.tbCustomFormat);
			this.Panel2.Controls.Add(this.Label5);
			this.Panel2.Location = new System.Drawing.Point(272, 120);
			this.Panel2.Name = "Panel2";
			this.Panel2.Size = new System.Drawing.Size(248, 80);
			this.Panel2.TabIndex = 19;
			// 
			// btnSetFormat
			// 
			this.btnSetFormat.Location = new System.Drawing.Point(152, 16);
			this.btnSetFormat.Name = "btnSetFormat";
			this.btnSetFormat.Size = new System.Drawing.Size(56, 23);
			this.btnSetFormat.TabIndex = 1;
			this.btnSetFormat.Text = "Set";
			this.btnSetFormat.Click += new System.EventHandler(this.btnSetFormat_Click);
			// 
			// dtpCustomFormat
			// 
			this.dtpCustomFormat.CustomFormat = "";
			this.dtpCustomFormat.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dtpCustomFormat.Location = new System.Drawing.Point(8, 48);
			this.dtpCustomFormat.Name = "dtpCustomFormat";
			this.dtpCustomFormat.TabIndex = 2;
			// 
			// tbCustomFormat
			// 
			this.tbCustomFormat.Location = new System.Drawing.Point(8, 16);
			this.tbCustomFormat.Name = "tbCustomFormat";
			this.tbCustomFormat.Size = new System.Drawing.Size(136, 20);
			this.tbCustomFormat.TabIndex = 0;
			this.tbCustomFormat.Text = "";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Location = new System.Drawing.Point(0, -32);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(109, 16);
			this.Label5.TabIndex = 13;
			this.Label5.Text = "Custom Date Format";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(288, 8);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(67, 16);
			this.Label4.TabIndex = 21;
			this.Label4.Text = "Date Format";
			// 
			// Panel1
			// 
			this.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel1.Controls.Add(this.rbTime);
			this.Panel1.Controls.Add(this.rbLong);
			this.Panel1.Controls.Add(this.rbShort);
			this.Panel1.Controls.Add(this.dtpFormat);
			this.Panel1.Location = new System.Drawing.Point(272, 16);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(248, 88);
			this.Panel1.TabIndex = 18;
			// 
			// rbTime
			// 
			this.rbTime.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbTime.Location = new System.Drawing.Point(168, 48);
			this.rbTime.Name = "rbTime";
			this.rbTime.Size = new System.Drawing.Size(48, 24);
			this.rbTime.TabIndex = 3;
			this.rbTime.Text = "Time";
			this.rbTime.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbTime.CheckedChanged += new System.EventHandler(this.rbTime_CheckedChanged);
			// 
			// rbLong
			// 
			this.rbLong.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbLong.Location = new System.Drawing.Point(92, 48);
			this.rbLong.Name = "rbLong";
			this.rbLong.Size = new System.Drawing.Size(48, 24);
			this.rbLong.TabIndex = 2;
			this.rbLong.Text = "Long";
			this.rbLong.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbLong.CheckedChanged += new System.EventHandler(this.rbLong_CheckedChanged);
			// 
			// rbShort
			// 
			this.rbShort.Appearance = System.Windows.Forms.Appearance.Button;
			this.rbShort.Checked = true;
			this.rbShort.Location = new System.Drawing.Point(16, 48);
			this.rbShort.Name = "rbShort";
			this.rbShort.Size = new System.Drawing.Size(48, 24);
			this.rbShort.TabIndex = 1;
			this.rbShort.TabStop = true;
			this.rbShort.Text = "Short";
			this.rbShort.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.rbShort.CheckedChanged += new System.EventHandler(this.rbShort_CheckedChanged);
			// 
			// dtpFormat
			// 
			this.dtpFormat.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpFormat.Location = new System.Drawing.Point(16, 16);
			this.dtpFormat.Name = "dtpFormat";
			this.dtpFormat.TabIndex = 0;
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(24, 72);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(92, 16);
			this.Label3.TabIndex = 20;
			this.Label3.Text = "Converting Dates";
			// 
			// ImageList1
			// 
			this.ImageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.ImageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList1.ImageStream")));
			this.ImageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Location = new System.Drawing.Point(32, 8);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(96, 16);
			this.Label7.TabIndex = 23;
			this.Label7.Text = "CheckBox Images";
			// 
			// daDates
			// 
			this.daDates.DeleteCommand = this.OleDbDeleteCommand1;
			this.daDates.InsertCommand = this.OleDbInsertCommand1;
			this.daDates.SelectCommand = this.OleDbSelectCommand2;
			this.daDates.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							  new System.Data.Common.DataTableMapping("Table", "Dates", new System.Data.Common.DataColumnMapping[] {
																																																	   new System.Data.Common.DataColumnMapping("SampleDate", "SampleDate")})});
			this.daDates.UpdateCommand = this.OleDbUpdateCommand1;
			// 
			// OleDbDeleteCommand1
			// 
			this.OleDbDeleteCommand1.CommandText = "DELETE FROM Dates WHERE (SampleDate = ?)";
			this.OleDbDeleteCommand1.Connection = this.cnChapter11;
			this.OleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_SampleDate", System.Data.OleDb.OleDbType.DBDate, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SampleDate", System.Data.DataRowVersion.Original, null));
			// 
			// pnlDates
			// 
			this.pnlDates.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlDates.Controls.Add(this.btnNextDate);
			this.pnlDates.Controls.Add(this.btnPreviousDate);
			this.pnlDates.Controls.Add(this.tbUTC);
			this.pnlDates.Controls.Add(this.Label2);
			this.pnlDates.Controls.Add(this.tbActual);
			this.pnlDates.Controls.Add(this.Label1);
			this.pnlDates.Location = new System.Drawing.Point(8, 80);
			this.pnlDates.Name = "pnlDates";
			this.pnlDates.Size = new System.Drawing.Size(248, 120);
			this.pnlDates.TabIndex = 17;
			// 
			// btnNextDate
			// 
			this.btnNextDate.BackColor = System.Drawing.Color.White;
			this.btnNextDate.Image = ((System.Drawing.Image)(resources.GetObject("btnNextDate.Image")));
			this.btnNextDate.Location = new System.Drawing.Point(56, 88);
			this.btnNextDate.Name = "btnNextDate";
			this.btnNextDate.Size = new System.Drawing.Size(40, 23);
			this.btnNextDate.TabIndex = 3;
			this.btnNextDate.Click += new System.EventHandler(this.btnNextDate_Click);
			// 
			// btnPreviousDate
			// 
			this.btnPreviousDate.BackColor = System.Drawing.Color.White;
			this.btnPreviousDate.Image = ((System.Drawing.Image)(resources.GetObject("btnPreviousDate.Image")));
			this.btnPreviousDate.Location = new System.Drawing.Point(8, 88);
			this.btnPreviousDate.Name = "btnPreviousDate";
			this.btnPreviousDate.Size = new System.Drawing.Size(40, 23);
			this.btnPreviousDate.TabIndex = 2;
			this.btnPreviousDate.Click += new System.EventHandler(this.btnPreviousDate_Click);
			// 
			// tbUTC
			// 
			this.tbUTC.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsChapter11, "Dates.SampleDate"));
			this.tbUTC.Location = new System.Drawing.Point(136, 48);
			this.tbUTC.Name = "tbUTC";
			this.tbUTC.TabIndex = 1;
			this.tbUTC.Text = "tbUTC";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(56, 48);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(75, 16);
			this.Label2.TabIndex = 7;
			this.Label2.Text = "Value in UTC:";
			// 
			// tbActual
			// 
			this.tbActual.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsChapter11, "Dates.SampleDate"));
			this.tbActual.Location = new System.Drawing.Point(136, 16);
			this.tbActual.Name = "tbActual";
			this.tbActual.TabIndex = 0;
			this.tbActual.Text = "tbActual";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(8, 16);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(123, 16);
			this.Label1.TabIndex = 5;
			this.Label1.Text = "Actual DateTime Value:";
			// 
			// Panel3
			// 
			this.Panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel3.Controls.Add(this.CheckBox1);
			this.Panel3.Location = new System.Drawing.Point(16, 16);
			this.Panel3.Name = "Panel3";
			this.Panel3.Size = new System.Drawing.Size(240, 40);
			this.Panel3.TabIndex = 16;
			// 
			// CheckBox1
			// 
			this.CheckBox1.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.CheckBox1.ImageIndex = 1;
			this.CheckBox1.ImageList = this.ImageList1;
			this.CheckBox1.Location = new System.Drawing.Point(16, 8);
			this.CheckBox1.Name = "CheckBox1";
			this.CheckBox1.TabIndex = 0;
			this.CheckBox1.Text = "CheckBox1";
			this.CheckBox1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.CheckBox1.CheckedChanged += new System.EventHandler(this.CheckBox1_CheckedChanged);
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Location = new System.Drawing.Point(280, 112);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(109, 16);
			this.Label6.TabIndex = 22;
			this.Label6.Text = "Custom Date Format";
			// 
			// dsChapter11
			// 
			this.dsChapter11.DataSetName = "dsChapter11";
			this.dsChapter11.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// ControlSamples
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 221);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.Label7);
			this.Controls.Add(this.Label6);
			this.Controls.Add(this.Label4);
			this.Controls.Add(this.pnlDates);
			this.Controls.Add(this.Panel3);
			this.Controls.Add(this.Panel2);
			this.Controls.Add(this.Panel1);
			this.Name = "ControlSamples";
			this.Text = "ControlSamples";
			this.Panel2.ResumeLayout(false);
			this.Panel1.ResumeLayout(false);
			this.pnlDates.ResumeLayout(false);
			this.Panel3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsChapter11)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new ControlSamples());
		}

		private void ToUTC(object sender, ConvertEventArgs e)
		{
			if ((string)this.tbUTC.Tag != "PARSE") 
			{
				System.DateTime dt = (System.DateTime)e.Value;
				e.Value = dt.ToUniversalTime();
			}
			this.tbUTC.Tag = "FORMAT";
		}

		private void ToLocal(object sender, ConvertEventArgs e)
		{
			System.DateTime dt = (System.DateTime)e.Value;

			e.Value = dt.ToLocalTime();
			this.tbUTC.Tag = "PARSE";
		}

		private void CheckBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.CheckBox1.CheckState == CheckState.Checked)
                this.CheckBox1.ImageIndex = 0;
			else
				this.CheckBox1.ImageIndex = 1;
		}

		private void btnPreviousDate_Click(object sender, System.EventArgs e)
		{
			if (bmbDates.Position != 1)
				bmbDates.Position -= 1;
		}

		private void btnNextDate_Click(object sender, System.EventArgs e)
		{
			if (bmbDates.Position != this.dsChapter11.Dates.Count)
				bmbDates.Position += 1;
		}

		private void rbShort_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.rbShort.Checked) 
				this.dtpFormat.Format = DateTimePickerFormat.Short;
		}

		private void rbLong_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.rbLong.Checked) 
				this.dtpFormat.Format = DateTimePickerFormat.Long;

		}

		private void rbTime_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.rbTime.Checked) 
				this.dtpFormat.Format = DateTimePickerFormat.Time;
		
		}

		private void btnSetFormat_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (this.tbCustomFormat.Text.Length > 0) 
					this.dtpCustomFormat.CustomFormat = this.tbCustomFormat.Text;
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}


	}
}
