using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace SortingSearchingFilteringCSharp
{
	/// <summary>
	/// Summary description for SortAndFind.
	/// </summary>
	public class SortAndFind : System.Windows.Forms.Form
	{
		private DataRowView[] foundRows;
		private int currentRow;

		internal System.Data.OleDb.OleDbConnection cnDataManipulation;
		internal System.Data.OleDb.OleDbDataAdapter daBooksExtended;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		private SortingSearchingFilteringCSharp.dsSortSearchFilter dsFrmSortSearchFilter;
		internal System.Windows.Forms.DataGrid dgBooks;
		internal System.Windows.Forms.Button btnFindNext;
		internal System.Windows.Forms.Button btnFind;
		internal System.Windows.Forms.TextBox tbFind;
		internal System.Windows.Forms.Label Label1;
		private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn2;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SortAndFind()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.daBooksExtended.Fill(this.dsFrmSortSearchFilter.BooksExtended);
			CurrencyManager cm = this.BindingContext[this.dgBooks.DataSource,
				this.dgBooks.DataMember] as CurrencyManager;
			DataView dg = cm.List as DataView;
			dg.Sort = "BookID";

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		[STAThread]
		static void Main()
		{
			Application.Run(new SortAndFind());
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cnDataManipulation = new System.Data.OleDb.OleDbConnection();
			this.daBooksExtended = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.dsFrmSortSearchFilter = new SortingSearchingFilteringCSharp.dsSortSearchFilter();
			this.dgBooks = new System.Windows.Forms.DataGrid();
			this.btnFindNext = new System.Windows.Forms.Button();
			this.btnFind = new System.Windows.Forms.Button();
			this.tbFind = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
			this.dataGridTextBoxColumn1 = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dataGridTextBoxColumn2 = new System.Windows.Forms.DataGridTextBoxColumn();
			this.dataGridTextBoxColumn3 = new System.Windows.Forms.DataGridTextBoxColumn();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmSortSearchFilter)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dgBooks)).BeginInit();
			this.SuspendLayout();
			// 
			// cnDataManipulation
			// 
			this.cnDataManipulation.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\DataManipulation.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// daBooksExtended
			// 
			this.daBooksExtended.SelectCommand = this.OleDbSelectCommand1;
			this.daBooksExtended.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "BooksExtended", new System.Data.Common.DataColumnMapping[] {
																																																					   new System.Data.Common.DataColumnMapping("Author", "Author"),
																																																					   new System.Data.Common.DataColumnMapping("BookID", "BookID"),
																																																					   new System.Data.Common.DataColumnMapping("Title", "Title")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT Author, BookID, Title FROM BooksExtended";
			this.OleDbSelectCommand1.Connection = this.cnDataManipulation;
			// 
			// dsFrmSortSearchFilter
			// 
			this.dsFrmSortSearchFilter.DataSetName = "dsSortSearchFilter";
			this.dsFrmSortSearchFilter.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// dgBooks
			// 
			this.dgBooks.DataMember = "";
			this.dgBooks.DataSource = this.dsFrmSortSearchFilter.BooksExtended;
			this.dgBooks.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgBooks.Location = new System.Drawing.Point(16, 82);
			this.dgBooks.Name = "dgBooks";
			this.dgBooks.Size = new System.Drawing.Size(592, 232);
			this.dgBooks.TabIndex = 9;
			this.dgBooks.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
																								this.dataGridTableStyle1});
			// 
			// btnFindNext
			// 
			this.btnFindNext.Enabled = false;
			this.btnFindNext.Location = new System.Drawing.Point(520, 42);
			this.btnFindNext.Name = "btnFindNext";
			this.btnFindNext.TabIndex = 8;
			this.btnFindNext.Text = "Find Next";
			this.btnFindNext.Click += new System.EventHandler(this.btnFindNext_Click);
			// 
			// btnFind
			// 
			this.btnFind.Location = new System.Drawing.Point(520, 10);
			this.btnFind.Name = "btnFind";
			this.btnFind.TabIndex = 7;
			this.btnFind.Text = "Find";
			this.btnFind.Click += new System.EventHandler(this.btnFind_Click);
			// 
			// tbFind
			// 
			this.tbFind.Location = new System.Drawing.Point(72, 10);
			this.tbFind.Name = "tbFind";
			this.tbFind.Size = new System.Drawing.Size(432, 20);
			this.tbFind.TabIndex = 6;
			this.tbFind.Text = "";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(16, 12);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(41, 16);
			this.Label1.TabIndex = 5;
			this.Label1.Text = "Author:";
			// 
			// dataGridTableStyle1
			// 
			this.dataGridTableStyle1.DataGrid = this.dgBooks;
			this.dataGridTableStyle1.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
																												  this.dataGridTextBoxColumn1,
																												  this.dataGridTextBoxColumn2,
																												  this.dataGridTextBoxColumn3});
			this.dataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTableStyle1.MappingName = "BooksExtended";
			this.dataGridTableStyle1.ReadOnly = true;
			// 
			// dataGridTextBoxColumn1
			// 
			this.dataGridTextBoxColumn1.Format = "";
			this.dataGridTextBoxColumn1.FormatInfo = null;
			this.dataGridTextBoxColumn1.HeaderText = "ID";
			this.dataGridTextBoxColumn1.MappingName = "BookID";
			this.dataGridTextBoxColumn1.Width = 50;
			// 
			// dataGridTextBoxColumn2
			// 
			this.dataGridTextBoxColumn2.Format = "";
			this.dataGridTextBoxColumn2.FormatInfo = null;
			this.dataGridTextBoxColumn2.HeaderText = "Title";
			this.dataGridTextBoxColumn2.MappingName = "Title";
			this.dataGridTextBoxColumn2.Width = 250;
			// 
			// dataGridTextBoxColumn3
			// 
			this.dataGridTextBoxColumn3.Format = "";
			this.dataGridTextBoxColumn3.FormatInfo = null;
			this.dataGridTextBoxColumn3.HeaderText = "Author";
			this.dataGridTextBoxColumn3.MappingName = "Author";
			this.dataGridTextBoxColumn3.Width = 250;
			// 
			// SortAndFind
			// 
			this.AcceptButton = this.btnFind;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 325);
			this.Controls.Add(this.dgBooks);
			this.Controls.Add(this.btnFindNext);
			this.Controls.Add(this.btnFind);
			this.Controls.Add(this.tbFind);
			this.Controls.Add(this.Label1);
			this.Name = "SortAndFind";
			this.Text = "SortAndFind";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmSortSearchFilter)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dgBooks)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnFind_Click(object sender, System.EventArgs e)
		{
			DataView dv = new DataView(this.dsFrmSortSearchFilter.BooksExtended);

			if ((this.tbFind.Text).Length > 0)
			{
				dv.Sort = "Author";
			
				foundRows = dv.FindRows(this.tbFind.Text);
				if (foundRows.Length == 0)
					MessageBox.Show("Author Not Found");
				else
				{
					if (foundRows.Length > 1)
						this.btnFindNext.Enabled = true;
					else
						this.btnFindNext.Enabled = false;

					currentRow = 0;
					SelectRow();
				}
			}
			else
				;
		}
		
		private void SelectRow()
		{
			CurrencyManager cm = this.BindingContext[this.dgBooks.DataSource, 
				this.dgBooks.DataMember] as CurrencyManager;
			DataView dgDv = cm.List as DataView;

			string dgSort = dgDv.Sort;
			if (dgSort.Substring(0) == "[")
				dgSort = dgSort.Substring(1, dgSort.Length - 1);

			if ((dgSort == "Author") & (currentRow > 0))
			{
				int	idx = this.dgBooks.CurrentRowIndex;
				this.dgBooks.UnSelect(idx);
				this.dgBooks.Select(idx + 1);
				this.dgBooks.CurrentRowIndex += 1;
			}
			else
			{
				int dgIdx = dgDv.Find(foundRows[currentRow].Row[dgSort]);

				this.dgBooks.UnSelect(this.dgBooks.CurrentRowIndex);
				this.dgBooks.Select(dgIdx);
				this.dgBooks.CurrentRowIndex = dgIdx;
			}

			currentRow += 1;
			if (currentRow == foundRows.Length)
				this.btnFindNext.Enabled = false;
		}

		private void btnFindNext_Click(object sender, System.EventArgs e)
		{
			SelectRow();
		}

		}
}
